﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample01
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码

            uint uiVer = 0; //版本号
            uint uiAgent = 0; //代理编号
            uint uiPID = 0;  //产品ID
            uint uiUID = 0;  //用户ID
            uint uiDevType = 0;//设备类型
            uint uiIsMother = 0; //母锁标识
            uint uiType = 0; //产品类型
            object vHID = null; //HID，硬件序列号
            object vBirthday = null; //生产日期

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号

            string strMsg;
            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();

            textBox1.Clear();
            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg = string.Format("枚举锁失败!\r\n");
                textBox1.Text += strMsg;
                return;
            }
            strMsg = String.Format("Enum Dongle ARM dongle: [{0}] . \r\n", uiCount);
            textBox1.Text = strMsg;


            for (uint i = 0; i < uiCount; i++)
            {
                //从枚举的数据中获取每一把加密锁的相关数据
                ryArmDongle.GetDongleInfo(bDongleInfo, i, ref uiVer, ref vBirthday,
                                          ref uiAgent, ref uiPID, ref uiUID, ref vHID,
                                          ref uiDevType, ref uiIsMother, ref uiType);

               //显示找到的锁的信息
                strMsg += string.Format("Dongle ARM Dongle [{0}] information: \r\n", i);
                strMsg += string.Format(">>COS Version: {0}.{1}.\r\n", (uiVer >> 8),(uiVer & 0x00FF));
                byte [] birthday = (byte[])vBirthday;
                strMsg += string.Format(">>Birthday: 20{0:X2}-{1:X2}-{2:X2} {3:X2}:{4:X2}:{5:X2}\r\n", birthday[0], birthday[1], 
                    birthday[2], birthday[3], birthday[4], birthday[5]);//注意出厂日期的格式
                strMsg += string.Format(">>Agent: {0:X4}\r\n", uiAgent);
                strMsg += string.Format(">>PID:{0:X4}\r\n", uiPID);
                strMsg += string.Format(">>UID:{0:X4}\r\n", uiUID);
                byte[] hid = (byte [])vHID;
                strMsg += string.Format(">>HID:{0:X2}{1:X2}{2:X2}{3:X2}{4:X2}{5:X2}{6:X2}{7:X2}\r\n", hid[0], hid[1], hid[2], hid[3]
                    , hid[4], hid[5], hid[6], hid[7]);
                strMsg += string.Format(">>IsMother:{0:X8}（0:不是母锁;1:代表是母锁）\r\n", uiIsMother);
                strMsg += string.Format(">>Dev Type:{0:X4}（0:HID设备;1:CCID设备）\r\n", uiDevType);
                strMsg += string.Format(">>Product Type:{0:X2}（0xFF:标准锁;0x00:时钟锁;0x01:时钟U盘锁;0x02:标准U盘锁）\r\n\r\n", uiType);
                textBox1.Text = strMsg;
            }

            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg = string.Format("打开锁失败!\r\n");
                textBox1.Text += strMsg;
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] ok!\r\n");
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg = string.Format("关闭锁失败!\r\n");
                textBox1.Text += strMsg;
                return;
            }

            strMsg += string.Format("Close Dongle ARM [0] ok!\r\n");
            textBox1.Text = strMsg;

        }
    }
}