﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample02
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";

            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;


            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] Success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify Administator PIN Success.\r\n", uiError);
            textBox1.Text = strMsg;


            //创建数据文件
            object dataAttr = null;
            uint uiSize = 1024;//文件大小
            ushort usRead = 0;//读权限
            ushort usWrite = 1;//写权限
            ushort usFileID = 0x1100;//文件ID
            uint uiBufferLen = 0;
            //构造数据文件属性结构
            ryArmDongle.Convert_DATA_FILE_ATTR_To_Buffer(uiSize, usRead, usWrite, ref dataAttr, ref uiBufferLen, ref uiError);
            ryArmDongle.CreateFile(uiHandle, DongleDef.FILE_DATA, usFileID, dataAttr, uiBufferLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("创建文件失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }

            byte []buffer = new byte [1024];
            for (i = 0; i < 1024; i++ )
            {
                buffer[i] = (byte)i;
            }
            object vData = (object)buffer;
            ushort usOffset = 0;
            ryArmDongle.WriteFile(uiHandle, DongleDef.FILE_DATA, usFileID, usOffset, vData, uiSize, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("写文件失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }

            Array.Clear(buffer, 0, 1024);
            ryArmDongle.ReadFile(uiHandle, usFileID, usOffset, ref vData, uiSize, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("读文件失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }

            strMsg += "Read data file result:\r\n";
            buffer = (byte[])vData;
            for (i = 0; i < 1024; i++ )
            {
                strMsg += string.Format("{0:X2} ", buffer[i]);
                if ((i + 1) % 16 == 0) strMsg += "\r\n";
            }
            textBox1.Text = strMsg;

            //列文件
            object vFileListBuffer = null;
            uint uiFileListBufferLen = 0;
            ryArmDongle.ListFile(uiHandle, DongleDef.FILE_DATA, ref vFileListBuffer, ref uiFileListBufferLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("列文件失败。错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            i = 0;
            while(true)
            {
                object vFileAttr = null;
                usFileID = 0;
                ryArmDongle.Convert_Buffer_To_FILE_LIST(vFileListBuffer, uiFileListBufferLen, (uint)i, DongleDef.FILE_DATA, ref usFileID, ref vFileAttr, ref uiError);
                if (uiError == DongleDef.DONGLE_INVALID_PARAMETER)
                {
                    break;
                }
                ryArmDongle.Convert_Buffer_To_DATA_FILE_ATTR(vFileAttr, ref uiSize, ref usRead, ref usWrite, ref uiError);
                strMsg += String.Format("List Data file[{0}]:\r\n", i);
                strMsg += String.Format("     File id   : {0:X4}\r\n", usFileID);
                strMsg += string.Format("     File size : {0:d}\r\n", uiSize);
                strMsg += string.Format("     Read file priv : {0:d1}\r\n", usRead);
                strMsg += string.Format("     Write file priv: {0:d1}\r\n", usWrite);
                textBox1.Text += strMsg;
                i++;
            }
            
            //删除该文件
            usFileID = 0x1100;
            ryArmDongle.DeleteFile(uiHandle, DongleDef.FILE_DATA, usFileID, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("删除文件失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Delete file success. \r\n");
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += "Close Dongle ARM Success.";
            textBox1.Text = strMsg;

        }
    }
}