﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample03
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";

            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;


            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] Success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify Administator PIN Success.\r\n", uiError);
            textBox1.Text = strMsg;

            //下载可执行程序,本示例中下载两个可执行文件。下载多个文件方法类似           
            object vExeBuffer = null;
            object vFileData1 = (object)g_progExeFile1;
            object vFileData2 = (object)g_progExeFile2;
            uint uiBufferLen = 0;
            uint uiExeCount = 2;//一共添加两个可执行程序。
            ryArmDongle.Add_EXE_FILE_INFO_To_Buffer(ref vExeBuffer, ref uiBufferLen, EXE_SIZE_1, 0x2200, 0, vFileData1, ref uiError);
            ryArmDongle.Add_EXE_FILE_INFO_To_Buffer(ref vExeBuffer, ref uiBufferLen, EXE_SIZE_2, 0x2211, 1, vFileData2, ref uiError);
            ryArmDongle.DownloadExeFile(uiHandle, uiExeCount, vExeBuffer, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("下载可执行文件失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Download exe file[2200,2211] success. \r\n");
            textBox1.Text = strMsg;
            ryArmDongle.Clear_EXE_FILE_INFO_Buffer(vExeBuffer, uiBufferLen, ref uiError);//清空vExeBuffer的值

            //运行可执行文件 (0x2211是一个sha1算法)
            ushort usFileID = 0x2211;
            byte [] bData = new byte [20]{0x12,0x13,0x14,0x15,0x16,0x11,0x11,0x11,0x11,0x11,
                                          0x11,0x11,0x11,0x11,0x17,0x11,0x11,0x11,0x11,0x11};
            object vData = (object)bData;
            ushort usInOutLen = 24;
            uint uiMain = 0;
            ryArmDongle.RunExeFile(uiHandle, usFileID, ref vData, usInOutLen, ref uiMain, ref uiError);            
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("运行执行文件失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Run exe file success.\r\n");
            strMsg += string.Format("The result :\r\n");
            bData = (byte[])vData;
            for (i = 0; i < bData.Length; i++)
            {
                strMsg += string.Format("{0:X2} ", bData[i]);
                //if ((i + 1) % 16 == 0) strMsg += "\r\n";                
            }
            strMsg += "\r\n";
            textBox1.Text = strMsg;
            

            //删除可执行文件
            usFileID = 0x2200;
            ryArmDongle.DeleteFile(uiHandle, DongleDef.FILE_EXE, usFileID, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("删除文件[ID:0x2200]失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Delete exe file [ID:0x2200] success. \r\n");
            textBox1.Text = strMsg;

            //删除可执行文件
            usFileID = 0x2211;
            ryArmDongle.DeleteFile(uiHandle, DongleDef.FILE_EXE, usFileID, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("删除文件[ID:0x2211]失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Delete exe file [ID:0x2211] success. \r\n");
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Close Dongle ARM success.\r\n", uiError);
            textBox1.Text = strMsg;

        }

        public const ushort EXE_SIZE_1 = 1776;
        public const ushort EXE_SIZE_2 = 1808;

        public byte[] g_progExeFile1 = new byte[]{
            0x00,0x0c,0x00,0x68,0x55,0x00,0x00,0x00,0x59,0x00,0x00,0x00,0x5b,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5d,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5f,0x00,0x00,0x00,0x61,0x00,0x00,0x00,
            0x03,0x48,0x85,0x46,0x00,0xf0,0x22,0xfb,0x00,0x48,0x00,0x47,0xb1,0x03,0x00,0x00,
            0x00,0x0c,0x00,0x68,0x03,0x48,0x00,0x47,0xfe,0xe7,0xfe,0xe7,0xfe,0xe7,0xfe,0xe7,
            0xfe,0xe7,0x00,0x00,0x41,0x00,0x00,0x00,0x10,0xb5,0xd2,0x48,0x00,0xf0,0x00,0xfa,
            0xd0,0x48,0x10,0x21,0x00,0x1d,0x00,0xf0,0xf1,0xf9,0x10,0xbd,0x10,0xb5,0xcd,0x48,
            0x00,0xf0,0xda,0xf9,0x02,0x20,0x00,0xf0,0xe0,0xf9,0x10,0xbd,0x1c,0xb5,0x01,0x20,
            0x80,0x02,0x00,0x90,0x00,0x20,0x69,0x46,0x88,0x80,0xc8,0x80,0x08,0x23,0x6a,0x46,
            0xc5,0x49,0x01,0x20,0x00,0xf0,0x96,0xf9,0x1c,0xbd,0x10,0xb5,0xc2,0x49,0x01,0x20,
            0x00,0xf0,0xb8,0xf9,0x10,0xbd,0x38,0xb5,0x88,0x22,0x80,0x21,0xbd,0x48,0x00,0xf0,
            0xd1,0xfa,0xbc,0x4b,0xbd,0x4c,0x00,0x93,0x80,0x23,0x00,0x22,0x21,0x46,0x01,0x20,
            0x00,0xf0,0x9a,0xf9,0x09,0x21,0x09,0x03,0x88,0x42,0x09,0xd1,0x80,0x21,0xb5,0x48,
            0x00,0xf0,0xc7,0xfa,0xb3,0x4b,0x80,0x22,0x00,0x21,0x20,0x46,0x00,0xf0,0x7e,0xf9,
            0x38,0xbd,0x10,0xb5,0xaf,0x48,0x00,0xf0,0xdf,0xf9,0x20,0x21,0xad,0x48,0x00,0xf0,
            0xb8,0xfa,0xac,0x48,0x20,0x30,0x00,0xf0,0xce,0xf9,0x10,0xbd,0x10,0xb5,0x88,0xb0,
            0x10,0x20,0x05,0x90,0x00,0x20,0xaa,0x4c,0x06,0x90,0x08,0x23,0x05,0xaa,0x21,0x46,
            0x04,0x20,0x00,0xf0,0x57,0xf9,0x09,0x21,0x09,0x03,0x88,0x42,0x0b,0xd1,0x10,0x21,
            0x01,0xa8,0x00,0xf0,0x93,0xf9,0x01,0xab,0x00,0x93,0x10,0x23,0x00,0x22,0x21,0x46,
            0x04,0x20,0x00,0xf0,0x61,0xf9,0x08,0xb0,0x10,0xbd,0x70,0xb5,0x99,0x49,0x10,0x22,
            0x88,0x18,0x05,0x46,0x00,0xf0,0x6a,0xfa,0x99,0x4c,0x00,0x22,0x23,0x46,0x10,0x21,
            0x28,0x46,0x00,0xf0,0x28,0xfa,0x93,0x48,0x29,0x46,0x20,0x30,0x10,0x22,0x05,0x46,
            0x00,0xf0,0x5c,0xfa,0x23,0x46,0x01,0x22,0x10,0x21,0x28,0x46,0x00,0xf0,0x1b,0xfa,
            0x70,0xbd,0x70,0xb5,0x8b,0x49,0x10,0x22,0x88,0x18,0x05,0x46,0x00,0xf0,0x4e,0xfa,
            0x8b,0x4c,0x00,0x22,0x23,0x46,0x10,0x21,0x28,0x46,0x00,0xf0,0x18,0xfa,0x85,0x48,
            0x29,0x46,0x20,0x30,0x10,0x22,0x05,0x46,0x00,0xf0,0x40,0xfa,0x23,0x46,0x01,0x22,
            0x10,0x21,0x28,0x46,0x00,0xf0,0x0b,0xfa,0x70,0xbd,0x7e,0x4a,0x10,0xb5,0x20,0x32,
            0x20,0x21,0x50,0x1a,0x00,0xf0,0x0f,0xfa,0x10,0xbd,0x7a,0x4a,0x10,0xb5,0x20,0x32,
            0x20,0x21,0x50,0x1a,0x00,0xf0,0x11,0xfa,0x10,0xbd,0xf0,0xb5,0xb7,0xb0,0x03,0x20,
            0x69,0x46,0x88,0x84,0xff,0x20,0x01,0x30,0xc8,0x84,0x00,0x20,0xc0,0x43,0x74,0x4f,
            0x00,0x26,0x0a,0x90,0x0c,0x23,0x09,0xaa,0x39,0x46,0x0b,0x96,0x03,0x20,0x00,0xf0,
            0xe9,0xf8,0x09,0x25,0x2d,0x03,0x6b,0x4c,0xa8,0x42,0x03,0xd0,0x20,0x80,0xa7,0x80,
            0x37,0xb0,0xf0,0xbd,0x0c,0xa9,0x38,0x46,0x00,0xf0,0x83,0xf9,0xa8,0x42,0x02,0xd0,
            0x20,0x80,0x68,0x49,0x1a,0xe0,0x20,0x21,0x01,0xa8,0x00,0xf0,0x17,0xf9,0x68,0x46,
            0x06,0x71,0x36,0xab,0x00,0x93,0x26,0xab,0x20,0x22,0x01,0xa9,0x38,0x46,0x00,0xf0,
            0x7a,0xf9,0xa8,0x42,0x02,0xd0,0x20,0x80,0x5f,0x49,0x07,0xe0,0x26,0xab,0x20,0x22,
            0x01,0xa9,0x15,0xa8,0x00,0xf0,0x7e,0xf9,0x5c,0x49,0x20,0x80,0xa1,0x80,0xd7,0xe7,
            0xf0,0xb5,0xb7,0xb0,0x03,0x20,0x69,0x46,0x88,0x84,0x81,0x20,0x00,0x02,0xc8,0x84,
            0x00,0x20,0xc0,0x43,0x53,0x4f,0x00,0x26,0x0a,0x90,0x0c,0x23,0x09,0xaa,0x39,0x46,
            0x0b,0x96,0x03,0x20,0x00,0xf0,0xa6,0xf8,0x09,0x25,0x2d,0x03,0x49,0x4c,0xa8,0x42,
            0x02,0xd0,0x20,0x80,0x79,0x10,0x23,0xe0,0x0c,0xa9,0x38,0x46,0x00,0xf0,0x66,0xf9,
            0xa8,0x42,0x02,0xd0,0x20,0x80,0xa7,0x80,0xb2,0xe7,0x20,0x21,0x01,0xa8,0x00,0xf0,
            0xd5,0xf8,0x68,0x46,0x06,0x71,0x36,0xab,0x00,0x93,0x26,0xab,0x20,0x22,0x01,0xa9,
            0x38,0x46,0x00,0xf0,0x5d,0xf9,0xa8,0x42,0x02,0xd0,0x20,0x80,0x3e,0x49,0x07,0xe0,
            0x26,0xab,0x20,0x22,0x01,0xa9,0x15,0xa8,0x00,0xf0,0x61,0xf9,0x3b,0x49,0x20,0x80,
            0xa1,0x80,0x95,0xe7,0xf0,0xb5,0xff,0xb0,0x8c,0xb0,0x09,0xa8,0x00,0x90,0x08,0x90,
            0x37,0x48,0x06,0x90,0x07,0x46,0xff,0x30,0x21,0x30,0x07,0x90,0x02,0x20,0x69,0x46,
            0x08,0x81,0x80,0x02,0x48,0x81,0x00,0x20,0xc0,0x43,0x03,0x90,0x00,0x20,0x2e,0x4e,
            0x04,0x90,0x20,0x37,0x0c,0x23,0x02,0xaa,0x31,0x46,0x02,0x20,0x00,0xf0,0x5a,0xf8,
            0x09,0x25,0x2d,0x03,0x23,0x4c,0xa8,0x42,0x02,0xd0,0x20,0x80,0x24,0x49,0x07,0xe0,
            0x30,0x46,0x00,0x99,0x00,0xf0,0xc9,0xf8,0xa8,0x42,0x05,0xd0,0x21,0x49,0x20,0x80,
            0xa1,0x80,0x7f,0xb0,0x0c,0xb0,0xf0,0xbd,0x20,0x21,0x06,0x98,0x00,0xf0,0x86,0xf8,
            0x20,0x22,0x18,0x48,0x06,0x99,0x00,0xf0,0x69,0xf9,0x00,0x23,0x05,0xaa,0x01,0x93,
            0x00,0x92,0x3b,0x46,0x20,0x22,0x30,0x46,0x06,0x99,0x00,0xf0,0xb8,0xf8,0xa8,0x42,
            0x02,0xd0,0x20,0x80,0xa6,0x80,0xe4,0xe7,0x01,0x23,0x05,0xaa,0x01,0x93,0x00,0x92,
            0x68,0x46,0x81,0x8a,0x38,0x46,0x07,0x9b,0x08,0x9a,0x00,0xf0,0xb9,0xf8,0x04,0x46,
            0x08,0x48,0x20,0x22,0x20,0x30,0x07,0x99,0x00,0xf0,0x48,0xf9,0x05,0x49,0x0b,0x48,
            0x40,0x31,0x0c,0x80,0x88,0x80,0x68,0x46,0x80,0x8a,0x08,0x81,0x20,0x46,0xc8,0xe7,
            0x5a,0xe6,0x00,0x00,0x00,0x00,0x00,0x68,0x34,0x12,0x00,0x00,0xff,0xff,0x00,0x00,
            0x11,0x11,0x00,0x00,0x22,0x22,0x00,0x00,0x33,0x33,0x00,0x00,0x44,0x44,0x00,0x00,
            0x00,0x0c,0x00,0x68,0x70,0xb5,0x93,0x4c,0x10,0x25,0x25,0x80,0xa0,0x80,0xe1,0x80,
            0x91,0x48,0xe3,0x60,0xa2,0x60,0x80,0x47,0x60,0x88,0x70,0xbd,0x70,0xb5,0x8d,0x4c,
            0x11,0x25,0x25,0x80,0x01,0x25,0xa5,0x80,0xe0,0x80,0x21,0x81,0x62,0x81,0x8a,0x48,
            0xe3,0x60,0x80,0x47,0x60,0x88,0x70,0xbd,0x70,0xb5,0x86,0x4c,0x12,0x26,0x04,0x9d,
            0x26,0x80,0xa0,0x80,0xe1,0x80,0x22,0x81,0x63,0x81,0x83,0x48,0xe5,0x60,0x80,0x47,
            0x60,0x88,0x70,0xbd,0x10,0xb5,0x7f,0x4c,0x13,0x22,0x22,0x80,0xa0,0x80,0x7e,0x48,
            0xe1,0x80,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x7a,0x4c,0x14,0x21,0x21,0x80,
            0x60,0x60,0x79,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x75,0x4c,0x15,0x21,
            0x21,0x80,0x20,0x71,0x74,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x71,0x4c,
            0x16,0x22,0x22,0x80,0x60,0x60,0x70,0x48,0x21,0x72,0x80,0x47,0x60,0x88,0x10,0xbd,
            0x10,0xb5,0x6c,0x4c,0x17,0x21,0x21,0x80,0x60,0x60,0x6b,0x48,0x80,0x47,0x60,0x88,
            0x10,0xbd,0x10,0xb5,0x67,0x4c,0x18,0x21,0x21,0x80,0x60,0x60,0x66,0x48,0x80,0x47,
            0x60,0x88,0x10,0xbd,0x10,0xb5,0x63,0x4c,0x29,0x21,0x21,0x80,0x60,0x60,0x62,0x48,
            0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x5e,0x4c,0x19,0x21,0x21,0x80,0x60,0x60,
            0x5d,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x5a,0x4c,0x1a,0x21,0x21,0x80,
            0x60,0x60,0x59,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x55,0x4c,0x1b,0x22,
            0x22,0x80,0xa0,0x80,0x54,0x48,0xa1,0x60,0x80,0x47,0x60,0x88,0x10,0xbd,0xf8,0xb5,
            0x50,0x4c,0x1c,0x25,0x07,0x9f,0x06,0x9e,0x25,0x80,0xa3,0x60,0x61,0x60,0xa2,0x81,
            0xe0,0x81,0x4d,0x48,0x27,0x82,0x80,0x47,0xa0,0x89,0x30,0x80,0x60,0x88,0xf8,0xbd,
            0xf8,0xb5,0x48,0x4c,0x1d,0x25,0x07,0x9f,0x06,0x9e,0x25,0x80,0xa3,0x60,0x60,0x60,
            0x21,0x82,0xe2,0x60,0x44,0x48,0x67,0x82,0x80,0x47,0x20,0x8a,0x30,0x80,0x60,0x88,
            0xf8,0xbd,0x10,0xb5,0x3f,0x4c,0x1e,0x22,0x22,0x80,0xa0,0x80,0x3e,0x48,0xa1,0x60,
            0x80,0x47,0x60,0x88,0x10,0xbd,0x70,0xb5,0x3a,0x4c,0x1f,0x26,0x04,0x9d,0x26,0x80,
            0xa3,0x60,0x61,0x60,0xa2,0x81,0xe0,0x81,0x37,0x48,0x80,0x47,0xa0,0x89,0x28,0x80,
            0x60,0x88,0x70,0xbd,0x70,0xb5,0x33,0x4c,0x20,0x25,0x25,0x80,0xa1,0x60,0x60,0x60,
            0x22,0x82,0x31,0x48,0xe3,0x60,0x80,0x47,0x60,0x88,0x70,0xbd,0x10,0xb5,0x2d,0x4c,
            0x21,0x22,0x22,0x80,0xa0,0x80,0x2c,0x48,0xa1,0x60,0x80,0x47,0x60,0x88,0x10,0xbd,
            0x70,0xb5,0x28,0x4c,0x22,0x26,0x04,0x9d,0x26,0x80,0xa3,0x60,0x61,0x60,0xa2,0x81,
            0xe0,0x81,0x25,0x48,0x80,0x47,0xa0,0x89,0x28,0x80,0x60,0x88,0x70,0xbd,0x70,0xb5,
            0x20,0x4c,0x23,0x25,0x25,0x80,0xa1,0x60,0x60,0x60,0x22,0x82,0x1e,0x48,0xe3,0x60,
            0x80,0x47,0x60,0x88,0x70,0xbd,0x70,0xb5,0x1a,0x4c,0x24,0x25,0x25,0x80,0xa1,0x60,
            0x60,0x60,0xa2,0x81,0x18,0x48,0xe3,0x81,0x80,0x47,0x60,0x88,0x70,0xbd,0x70,0xb5,
            0x14,0x4c,0x25,0x25,0x25,0x80,0xa1,0x60,0x60,0x60,0xa2,0x81,0x12,0x48,0xe3,0x81,
            0x80,0x47,0x60,0x88,0x70,0xbd,0x10,0xb5,0x0e,0x4c,0x26,0x23,0x23,0x80,0x23,0x1d,
            0x07,0xc3,0x0d,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x09,0x4c,0x27,0x23,
            0x23,0x80,0x23,0x1d,0x07,0xc3,0x08,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,
            0x04,0x4c,0x28,0x23,0x23,0x80,0x23,0x1d,0x07,0xc3,0x03,0x48,0x80,0x47,0x60,0x88,
            0x10,0xbd,0x00,0x00,0x00,0x14,0x00,0x68,0x01,0x7f,0x00,0x00,0x70,0xb5,0x06,0x46,
            0x08,0x46,0x15,0x46,0x00,0xf0,0x0c,0xf8,0x34,0x46,0x03,0xe0,0x01,0x78,0x40,0x1c,
            0x21,0x70,0x64,0x1c,0x6d,0x1e,0xf9,0xd2,0x30,0x46,0x70,0xbd,0xee,0xe7,0xed,0xe7,
            0x0d,0x21,0xc9,0x06,0x88,0x42,0x02,0xd2,0x01,0x49,0xc9,0x6b,0x08,0x18,0x70,0x47,
            0xc0,0x1f,0x00,0x68,0xd2,0xb2,0x01,0xe0,0x02,0x70,0x40,0x1c,0x49,0x1e,0xfb,0xd2,
            0x70,0x47,0x00,0x22,0xf6,0xe7,0x10,0xb5,0x04,0x46,0x08,0x46,0x11,0x46,0x02,0x46,
            0x20,0x46,0xff,0xf7,0xef,0xff,0x20,0x46,0x10,0xbd,0x00,0x00,0x06,0x4c,0x01,0x25,
            0x06,0x4e,0x05,0xe0,0x20,0x46,0xe3,0x68,0x07,0xc8,0x2b,0x43,0x98,0x47,0x10,0x34,
            0xb4,0x42,0xf7,0xd3,0xff,0xf7,0xd0,0xfc,0xd0,0x06,0x00,0x00,0xf0,0x06,0x00,0x00,
            0x02,0xe0,0x08,0xc8,0x12,0x1f,0x08,0xc1,0x00,0x2a,0xfa,0xd1,0x70,0x47,0x70,0x47,
            0x00,0x20,0x01,0xe0,0x01,0xc1,0x12,0x1f,0x00,0x2a,0xfb,0xd1,0x70,0x47,0x00,0x00,
            0xf0,0x06,0x00,0x00,0x00,0x04,0x00,0x68,0x00,0x08,0x00,0x00,0xc0,0x06,0x00,0x00,
            0xf0,0x06,0x00,0x00,0x00,0x0c,0x00,0x68,0x00,0x04,0x00,0x00,0xc0,0x06,0x00,0x00};

       
        public byte[] g_progExeFile2 = new byte[]{
            0x00,0x0c,0x00,0x68,0x55,0x00,0x00,0x00,0x59,0x00,0x00,0x00,0x5b,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5d,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5f,0x00,0x00,0x00,0x61,0x00,0x00,0x00,
            0x03,0x48,0x85,0x46,0x00,0xf0,0x32,0xfb,0x00,0x48,0x00,0x47,0xd3,0x03,0x00,0x00,
            0x00,0x0c,0x00,0x68,0x03,0x48,0x00,0x47,0xfe,0xe7,0xfe,0xe7,0xfe,0xe7,0xfe,0xe7,
            0xfe,0xe7,0x00,0x00,0x41,0x00,0x00,0x00,0x10,0xb5,0xda,0x48,0x00,0xf0,0x10,0xfa,
            0xd8,0x48,0x10,0x21,0x00,0x1d,0x00,0xf0,0x01,0xfa,0x10,0xbd,0x10,0xb5,0xd5,0x48,
            0x00,0xf0,0xea,0xf9,0x02,0x20,0x00,0xf0,0xf0,0xf9,0x10,0xbd,0x1c,0xb5,0x01,0x20,
            0x80,0x02,0x00,0x90,0x00,0x20,0x69,0x46,0x88,0x80,0xc8,0x80,0x08,0x23,0x6a,0x46,
            0xcd,0x49,0x01,0x20,0x00,0xf0,0xa6,0xf9,0x1c,0xbd,0x10,0xb5,0xca,0x49,0x01,0x20,
            0x00,0xf0,0xc8,0xf9,0x10,0xbd,0x38,0xb5,0x88,0x22,0x80,0x21,0xc5,0x48,0x00,0xf0,
            0xe1,0xfa,0xc4,0x4b,0xc5,0x4c,0x00,0x93,0x80,0x23,0x00,0x22,0x21,0x46,0x01,0x20,
            0x00,0xf0,0xaa,0xf9,0x09,0x21,0x09,0x03,0x88,0x42,0x09,0xd1,0x80,0x21,0xbd,0x48,
            0x00,0xf0,0xd7,0xfa,0xbb,0x4b,0x80,0x22,0x00,0x21,0x20,0x46,0x00,0xf0,0x8e,0xf9,
            0x38,0xbd,0x10,0xb5,0xb7,0x48,0x00,0xf0,0xef,0xf9,0x20,0x21,0xb5,0x48,0x00,0xf0,
            0xc8,0xfa,0xb4,0x48,0x20,0x30,0x00,0xf0,0xde,0xf9,0x10,0xbd,0x10,0xb5,0x88,0xb0,
            0x10,0x20,0x05,0x90,0x00,0x20,0xb2,0x4c,0x06,0x90,0x08,0x23,0x05,0xaa,0x21,0x46,
            0x04,0x20,0x00,0xf0,0x67,0xf9,0x09,0x21,0x09,0x03,0x88,0x42,0x0b,0xd1,0x10,0x21,
            0x01,0xa8,0x00,0xf0,0xa3,0xf9,0x01,0xab,0x00,0x93,0x10,0x23,0x00,0x22,0x21,0x46,
            0x04,0x20,0x00,0xf0,0x71,0xf9,0x08,0xb0,0x10,0xbd,0x70,0xb5,0xa1,0x49,0x10,0x22,
            0x88,0x18,0x05,0x46,0x00,0xf0,0x7a,0xfa,0xa1,0x4c,0x00,0x22,0x23,0x46,0x10,0x21,
            0x28,0x46,0x00,0xf0,0x38,0xfa,0x9b,0x48,0x29,0x46,0x20,0x30,0x10,0x22,0x05,0x46,
            0x00,0xf0,0x6c,0xfa,0x23,0x46,0x01,0x22,0x10,0x21,0x28,0x46,0x00,0xf0,0x2b,0xfa,
            0x70,0xbd,0x70,0xb5,0x93,0x49,0x10,0x22,0x88,0x18,0x05,0x46,0x00,0xf0,0x5e,0xfa,
            0x93,0x4c,0x00,0x22,0x23,0x46,0x10,0x21,0x28,0x46,0x00,0xf0,0x28,0xfa,0x8d,0x48,
            0x29,0x46,0x20,0x30,0x10,0x22,0x05,0x46,0x00,0xf0,0x50,0xfa,0x23,0x46,0x01,0x22,
            0x10,0x21,0x28,0x46,0x00,0xf0,0x1b,0xfa,0x70,0xbd,0x10,0xb5,0x86,0xb0,0x14,0x21,
            0x68,0x46,0x00,0xf0,0x66,0xfa,0x6a,0x46,0x20,0x21,0x82,0x48,0x00,0xf0,0x1b,0xfa,
            0x04,0x46,0x01,0x21,0x89,0x02,0x7f,0x48,0x00,0xf0,0x5b,0xfa,0x14,0x22,0x69,0x46,
            0x7c,0x48,0x00,0xf0,0x33,0xfa,0x20,0x46,0x06,0xb0,0x10,0xbd,0x79,0x4a,0x10,0xb5,
            0x20,0x32,0x20,0x21,0x50,0x1a,0x00,0xf0,0x10,0xfa,0x10,0xbd,0xf0,0xb5,0xb7,0xb0,
            0x03,0x20,0x69,0x46,0x88,0x84,0xff,0x20,0x01,0x30,0xc8,0x84,0x00,0x20,0xc0,0x43,
            0x73,0x4f,0x00,0x26,0x0a,0x90,0x0c,0x23,0x09,0xaa,0x39,0x46,0x0b,0x96,0x03,0x20,
            0x00,0xf0,0xe8,0xf8,0x09,0x25,0x2d,0x03,0x6a,0x4c,0xa8,0x42,0x03,0xd0,0x20,0x80,
            0xa7,0x80,0x37,0xb0,0xf0,0xbd,0x0c,0xa9,0x38,0x46,0x00,0xf0,0x82,0xf9,0xa8,0x42,
            0x02,0xd0,0x20,0x80,0x67,0x49,0x1a,0xe0,0x20,0x21,0x01,0xa8,0x00,0xf0,0x16,0xf9,
            0x68,0x46,0x06,0x71,0x36,0xab,0x00,0x93,0x26,0xab,0x20,0x22,0x01,0xa9,0x38,0x46,
            0x00,0xf0,0x79,0xf9,0xa8,0x42,0x02,0xd0,0x20,0x80,0x5f,0x49,0x07,0xe0,0x26,0xab,
            0x20,0x22,0x01,0xa9,0x15,0xa8,0x00,0xf0,0x7d,0xf9,0x5c,0x49,0x20,0x80,0xa1,0x80,
            0xd7,0xe7,0xf0,0xb5,0xb7,0xb0,0x03,0x20,0x69,0x46,0x88,0x84,0x81,0x20,0x00,0x02,
            0xc8,0x84,0x00,0x20,0xc0,0x43,0x53,0x4f,0x00,0x26,0x0a,0x90,0x0c,0x23,0x09,0xaa,
            0x39,0x46,0x0b,0x96,0x03,0x20,0x00,0xf0,0xa5,0xf8,0x09,0x25,0x2d,0x03,0x49,0x4c,
            0xa8,0x42,0x02,0xd0,0x20,0x80,0x79,0x10,0x23,0xe0,0x0c,0xa9,0x38,0x46,0x00,0xf0,
            0x65,0xf9,0xa8,0x42,0x02,0xd0,0x20,0x80,0xa7,0x80,0xb2,0xe7,0x20,0x21,0x01,0xa8,
            0x00,0xf0,0xd4,0xf8,0x68,0x46,0x06,0x71,0x36,0xab,0x00,0x93,0x26,0xab,0x20,0x22,
            0x01,0xa9,0x38,0x46,0x00,0xf0,0x5c,0xf9,0xa8,0x42,0x02,0xd0,0x20,0x80,0x3e,0x49,
            0x07,0xe0,0x26,0xab,0x20,0x22,0x01,0xa9,0x15,0xa8,0x00,0xf0,0x60,0xf9,0x3b,0x49,
            0x20,0x80,0xa1,0x80,0x95,0xe7,0xf0,0xb5,0xff,0xb0,0x8c,0xb0,0x09,0xa8,0x00,0x90,
            0x08,0x90,0x37,0x48,0x06,0x90,0x07,0x46,0xff,0x30,0x21,0x30,0x07,0x90,0x02,0x20,
            0x69,0x46,0x08,0x81,0x80,0x02,0x48,0x81,0x00,0x20,0xc0,0x43,0x03,0x90,0x00,0x20,
            0x2d,0x4e,0x04,0x90,0x20,0x37,0x0c,0x23,0x02,0xaa,0x31,0x46,0x02,0x20,0x00,0xf0,
            0x59,0xf8,0x09,0x25,0x2d,0x03,0x23,0x4c,0xa8,0x42,0x02,0xd0,0x20,0x80,0x24,0x49,
            0x07,0xe0,0x30,0x46,0x00,0x99,0x00,0xf0,0xc8,0xf8,0xa8,0x42,0x05,0xd0,0x21,0x49,
            0x20,0x80,0xa1,0x80,0x7f,0xb0,0x0c,0xb0,0xf0,0xbd,0x20,0x21,0x06,0x98,0x00,0xf0,
            0x85,0xf8,0x20,0x22,0x17,0x48,0x06,0x99,0x00,0xf0,0x68,0xf9,0x00,0x23,0x05,0xaa,
            0x01,0x93,0x00,0x92,0x3b,0x46,0x20,0x22,0x30,0x46,0x06,0x99,0x00,0xf0,0xb7,0xf8,
            0xa8,0x42,0x02,0xd0,0x20,0x80,0xa6,0x80,0xe4,0xe7,0x01,0x23,0x05,0xaa,0x01,0x93,
            0x00,0x92,0x68,0x46,0x81,0x8a,0x38,0x46,0x07,0x9b,0x08,0x9a,0x00,0xf0,0xb8,0xf8,
            0x04,0x46,0x08,0x48,0x20,0x22,0x20,0x30,0x07,0x99,0x00,0xf0,0x47,0xf9,0x05,0x49,
            0x0a,0x48,0x40,0x31,0x0c,0x80,0x88,0x80,0x68,0x46,0x80,0x8a,0x08,0x81,0x20,0x46,
            0xc8,0xe7,0xf2,0xe6,0x00,0x00,0x00,0x68,0x34,0x12,0x00,0x00,0xff,0xff,0x00,0x00,
            0x11,0x11,0x00,0x00,0x22,0x22,0x00,0x00,0x33,0x33,0x00,0x00,0x44,0x44,0x00,0x00,
            0x00,0x0c,0x00,0x68,0x70,0xb5,0x93,0x4c,0x10,0x25,0x25,0x80,0xa0,0x80,0xe1,0x80,
            0x91,0x48,0xe3,0x60,0xa2,0x60,0x80,0x47,0x60,0x88,0x70,0xbd,0x70,0xb5,0x8d,0x4c,
            0x11,0x25,0x25,0x80,0x01,0x25,0xa5,0x80,0xe0,0x80,0x21,0x81,0x62,0x81,0x8a,0x48,
            0xe3,0x60,0x80,0x47,0x60,0x88,0x70,0xbd,0x70,0xb5,0x86,0x4c,0x12,0x26,0x04,0x9d,
            0x26,0x80,0xa0,0x80,0xe1,0x80,0x22,0x81,0x63,0x81,0x83,0x48,0xe5,0x60,0x80,0x47,
            0x60,0x88,0x70,0xbd,0x10,0xb5,0x7f,0x4c,0x13,0x22,0x22,0x80,0xa0,0x80,0x7e,0x48,
            0xe1,0x80,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x7a,0x4c,0x14,0x21,0x21,0x80,
            0x60,0x60,0x79,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x75,0x4c,0x15,0x21,
            0x21,0x80,0x20,0x71,0x74,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x71,0x4c,
            0x16,0x22,0x22,0x80,0x60,0x60,0x70,0x48,0x21,0x72,0x80,0x47,0x60,0x88,0x10,0xbd,
            0x10,0xb5,0x6c,0x4c,0x17,0x21,0x21,0x80,0x60,0x60,0x6b,0x48,0x80,0x47,0x60,0x88,
            0x10,0xbd,0x10,0xb5,0x67,0x4c,0x18,0x21,0x21,0x80,0x60,0x60,0x66,0x48,0x80,0x47,
            0x60,0x88,0x10,0xbd,0x10,0xb5,0x63,0x4c,0x29,0x21,0x21,0x80,0x60,0x60,0x62,0x48,
            0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x5e,0x4c,0x19,0x21,0x21,0x80,0x60,0x60,
            0x5d,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x5a,0x4c,0x1a,0x21,0x21,0x80,
            0x60,0x60,0x59,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x55,0x4c,0x1b,0x22,
            0x22,0x80,0xa0,0x80,0x54,0x48,0xa1,0x60,0x80,0x47,0x60,0x88,0x10,0xbd,0xf8,0xb5,
            0x50,0x4c,0x1c,0x25,0x07,0x9f,0x06,0x9e,0x25,0x80,0xa3,0x60,0x61,0x60,0xa2,0x81,
            0xe0,0x81,0x4d,0x48,0x27,0x82,0x80,0x47,0xa0,0x89,0x30,0x80,0x60,0x88,0xf8,0xbd,
            0xf8,0xb5,0x48,0x4c,0x1d,0x25,0x07,0x9f,0x06,0x9e,0x25,0x80,0xa3,0x60,0x60,0x60,
            0x21,0x82,0xe2,0x60,0x44,0x48,0x67,0x82,0x80,0x47,0x20,0x8a,0x30,0x80,0x60,0x88,
            0xf8,0xbd,0x10,0xb5,0x3f,0x4c,0x1e,0x22,0x22,0x80,0xa0,0x80,0x3e,0x48,0xa1,0x60,
            0x80,0x47,0x60,0x88,0x10,0xbd,0x70,0xb5,0x3a,0x4c,0x1f,0x26,0x04,0x9d,0x26,0x80,
            0xa3,0x60,0x61,0x60,0xa2,0x81,0xe0,0x81,0x37,0x48,0x80,0x47,0xa0,0x89,0x28,0x80,
            0x60,0x88,0x70,0xbd,0x70,0xb5,0x33,0x4c,0x20,0x25,0x25,0x80,0xa1,0x60,0x60,0x60,
            0x22,0x82,0x31,0x48,0xe3,0x60,0x80,0x47,0x60,0x88,0x70,0xbd,0x10,0xb5,0x2d,0x4c,
            0x21,0x22,0x22,0x80,0xa0,0x80,0x2c,0x48,0xa1,0x60,0x80,0x47,0x60,0x88,0x10,0xbd,
            0x70,0xb5,0x28,0x4c,0x22,0x26,0x04,0x9d,0x26,0x80,0xa3,0x60,0x61,0x60,0xa2,0x81,
            0xe0,0x81,0x25,0x48,0x80,0x47,0xa0,0x89,0x28,0x80,0x60,0x88,0x70,0xbd,0x70,0xb5,
            0x20,0x4c,0x23,0x25,0x25,0x80,0xa1,0x60,0x60,0x60,0x22,0x82,0x1e,0x48,0xe3,0x60,
            0x80,0x47,0x60,0x88,0x70,0xbd,0x70,0xb5,0x1a,0x4c,0x24,0x25,0x25,0x80,0xa1,0x60,
            0x60,0x60,0xa2,0x81,0x18,0x48,0xe3,0x81,0x80,0x47,0x60,0x88,0x70,0xbd,0x70,0xb5,
            0x14,0x4c,0x25,0x25,0x25,0x80,0xa1,0x60,0x60,0x60,0xa2,0x81,0x12,0x48,0xe3,0x81,
            0x80,0x47,0x60,0x88,0x70,0xbd,0x10,0xb5,0x0e,0x4c,0x26,0x23,0x23,0x80,0x23,0x1d,
            0x07,0xc3,0x0d,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,0x09,0x4c,0x27,0x23,
            0x23,0x80,0x23,0x1d,0x07,0xc3,0x08,0x48,0x80,0x47,0x60,0x88,0x10,0xbd,0x10,0xb5,
            0x04,0x4c,0x28,0x23,0x23,0x80,0x23,0x1d,0x07,0xc3,0x03,0x48,0x80,0x47,0x60,0x88,
            0x10,0xbd,0x00,0x00,0x00,0x14,0x00,0x68,0x01,0x7f,0x00,0x00,0x70,0xb5,0x06,0x46,
            0x08,0x46,0x15,0x46,0x00,0xf0,0x0c,0xf8,0x34,0x46,0x03,0xe0,0x01,0x78,0x40,0x1c,
            0x21,0x70,0x64,0x1c,0x6d,0x1e,0xf9,0xd2,0x30,0x46,0x70,0xbd,0xee,0xe7,0xed,0xe7,
            0x0d,0x21,0xc9,0x06,0x88,0x42,0x02,0xd2,0x01,0x49,0xc9,0x6b,0x08,0x18,0x70,0x47,
            0xc0,0x1f,0x00,0x68,0xd2,0xb2,0x01,0xe0,0x02,0x70,0x40,0x1c,0x49,0x1e,0xfb,0xd2,
            0x70,0x47,0x00,0x22,0xf6,0xe7,0x10,0xb5,0x04,0x46,0x08,0x46,0x11,0x46,0x02,0x46,
            0x20,0x46,0xff,0xf7,0xef,0xff,0x20,0x46,0x10,0xbd,0x00,0x00,0x06,0x4c,0x01,0x25,
            0x06,0x4e,0x05,0xe0,0x20,0x46,0xe3,0x68,0x07,0xc8,0x2b,0x43,0x98,0x47,0x10,0x34,
            0xb4,0x42,0xf7,0xd3,0xff,0xf7,0xc0,0xfc,0xf0,0x06,0x00,0x00,0x10,0x07,0x00,0x00,
            0x02,0xe0,0x08,0xc8,0x12,0x1f,0x08,0xc1,0x00,0x2a,0xfa,0xd1,0x70,0x47,0x70,0x47,
            0x00,0x20,0x01,0xe0,0x01,0xc1,0x12,0x1f,0x00,0x2a,0xfb,0xd1,0x70,0x47,0x00,0x00,
            0x10,0x07,0x00,0x00,0x00,0x04,0x00,0x68,0x00,0x08,0x00,0x00,0xe0,0x06,0x00,0x00,
            0x10,0x07,0x00,0x00,0x00,0x0c,0x00,0x68,0x00,0x04,0x00,0x00,0xe0,0x06,0x00,0x00};
    }
    
}