﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample04
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        { 
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商PIN码
            string sNewPin = "1111111111111111";//新开发商PIN码
            string sUserPin = "12345678";
            uint uiRemainCount = 0;

            byte[] bSeed = null;//种子码大小可以为1~250

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";

            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;

            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n", uiError);
            textBox1.Text = strMsg;

            //唯一化锁
            bSeed = new byte[32];
            for (i = 0; i < 32; i++)
            {
                bSeed[i] = (byte)0x11;
            }
            uint uiSeedLen = 32;
            string strPID = "";
            string strAdminPIN = "";
            ryArmDongle.GenUniqueKey(uiHandle, uiSeedLen, (object)bSeed, ref strPID, ref strAdminPIN, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("唯一化锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("gen unique dongle success.\r\n", uiError);
            textBox1.Text = strMsg;

            //验证用户密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_USERPIN, sUserPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验用户PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify user pin success.\r\n", uiError);
            textBox1.Text = strMsg;

            //取消密码验证状态
            ryArmDongle.ResetState(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("重置COS安全状态失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Reset cos state success.\r\n", uiError);
            textBox1.Text = strMsg;

            //再次验证开发商密码,新的密码，别弄错了。
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, strAdminPIN, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("再次校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success again.\r\n", uiError);
            textBox1.Text = strMsg;

            //修改开发商密码
            uint uiTryCount = 0xFF;//255表示不限制重试次数，1~253表示
            ryArmDongle.ChangePIN(uiHandle, DongleDef.FLAG_ADMINPIN, strAdminPIN, sNewPin, uiTryCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("修改用户PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Modify user pin[=\"1111111111111111\"] success.\r\n", uiError);
            textBox1.Text = strMsg;

            //一键恢复出厂设置
            ryArmDongle.RFS(ref uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("一键恢复出厂设置失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("RFS success.\r\n", uiError);
            textBox1.Text = strMsg;

            //恢复出产设置后加密锁句柄无效，无需关闭加密锁
            //如果必须调用关闭函数，则返回0xF0000002,这属于正常
            ryArmDongle.Close(uiHandle, ref uiError);
            //if (uiError != DongleDef.DONGLE_SUCCESS)
            //{
            //    strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
            //    textBox1.Text = strMsg;
            //    return;
            //}
            strMsg += string.Format("Close Dongle ARM .\r\n", uiError);
            textBox1.Text = strMsg;

        }
    }
}