﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample05
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {//该操作只能对唯一化锁操作过的加密锁进行操作

            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            string sOldUserPin = "12345678";
            string sNewUserPin = "87654321";
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";
            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;

            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n");
            textBox1.Text = strMsg;

            //唯一化锁
            byte []bSeed = new byte[32];
            for (i = 0; i < 32; i++)
            {
                bSeed[i] = (byte)0x11;
            }
            uint uiSeedLen = 32;
            string strPID = "";
            string strAdminPIN = "";
            ryArmDongle.GenUniqueKey(uiHandle, uiSeedLen, (object)bSeed, ref strPID, ref strAdminPIN, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("唯一化锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("gen unique dongle success.\r\n", uiError);
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, strAdminPIN, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success again.\r\n", uiError);
            textBox1.Text = strMsg;


            //修改用户密码
            uint uiTryCount = 0xFF;//255表示不限制重试次数，1~253表示
            ryArmDongle.ChangePIN(uiHandle, DongleDef.FLAG_USERPIN, sOldUserPin, sNewUserPin, uiTryCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("修改用户PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Modify user pin[=\"87654321\"] success.\r\n", uiError);
            textBox1.Text = strMsg;

            //取消密码验证状态
            ryArmDongle.ResetState(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("重置COS安全状态失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Reset cos state success.\r\n", uiError);
            textBox1.Text = strMsg;

            //验证旧的用户PIN码，结果应该错误
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_USERPIN, sOldUserPin, ref uiRemainCount, ref uiError);
            strMsg += string.Format("Verify old user pin return : {0:X8}\r\n", uiError);

            //验证新的用户PIN码，结果应该成功
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_USERPIN, sNewUserPin, ref uiRemainCount, ref uiError);
            strMsg += string.Format("Verify new user pin return : {0:X8}\r\n", uiError);

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, strAdminPIN, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success again.\r\n", uiError);
            textBox1.Text = strMsg;

            //设置用户ID为0x12345678
            uint uiUserID = 0x12345678;
            ryArmDongle.SetUserID(uiHandle, uiUserID, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("设置用户ID失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Set user id success.\r\n", uiError);
            textBox1.Text = strMsg;

            //将用户PIN码恢复到"12345678"
            ryArmDongle.ResetUserPIN(uiHandle, strAdminPIN, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("重置用户PIN码失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Reset user pin[=\"12345678\"] success.\r\n", uiError);
            textBox1.Text = strMsg;

            //一键恢复出厂设置
            ryArmDongle.RFS(ref uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("一键恢复出厂设置失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
				ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("RFS success.\r\n", uiError);
            textBox1.Text = strMsg;

            //一键恢复出厂设置后，加密锁句柄无效，无需再关闭加密锁
            //如果再次之后调用关闭操作，则返回0xF0000002，这属于正常
            ryArmDongle.Close(uiHandle, ref uiError);
            //if (uiError != DongleDef.DONGLE_SUCCESS)
            //{
            //    strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
            //    textBox1.Text = strMsg;
            //    return;
            //}
            strMsg += string.Format("Close Dongle ARM .\r\n", uiError);
            textBox1.Text = strMsg;
        }
    }
}