﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample06
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";
            int i = 0;
            int nIndex = -1;

            //加密锁信息
            uint uiVer = 0; //版本号
            uint uiAgent = 0; //代理编号
            uint uiPID = 0;  //产品ID
            uint uiUID = 0;  //用户ID
            uint uiDevType = 0;//设备类型
            uint uiIsMother = 0; //母锁标识
            uint uiType = 0; //产品类型
            object vHID = null; //HID，硬件序列号
            object vBirthday = null; //生产日期
            
            System.DateTime standardTime = new System.DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);//计时的参照时间
             
            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;

            for (i = 0; i < uiCount; i++)
            {
                
                //从枚举的数据中获取每一把加密锁的相关数据
                ryArmDongle.GetDongleInfo(bDongleInfo, (uint)i, ref uiVer, ref vBirthday,
                                          ref uiAgent, ref uiPID, ref uiUID, ref vHID,
                                          ref uiDevType, ref uiIsMother, ref uiType);

                //判断是否有时钟锁
                if (uiType == 0x00 || uiType == 0x01)
                {
                    nIndex = i;
                    break;
                }              
            }

            if (nIndex == -1)
            {
                strMsg += string.Format("未找到时钟锁。");
                textBox1.Text = strMsg;
                return;
            }
            
            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;                
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n");
            textBox1.Text = strMsg;

            //获取锁内时钟时间
            uint uiTime = 0;
            ryArmDongle.GetUTCTime(uiHandle, ref uiTime, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("获取UTC时间失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }

            //时间转换
            Double secs = Convert.ToDouble(uiTime);
            System.DateTime dateTime = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc).AddSeconds(secs);

            strMsg += string.Format("Get UTC time success.\r\n", uiError);
            strMsg += string.Format("Time: {0:d4}-{1:d2}-{2:d2} {3:d2}:{4:d2}:{5:d2}\r\n",
                dateTime.Year,dateTime.Month,dateTime.Day,dateTime.Hour,dateTime.Minute,dateTime.Second);
            textBox1.Text = strMsg;

            //设置到期时间       
            //1.设置小时数。例：24小时
            uiTime = 24; //1~65535代表小时数，设置小时数从校验用户pin码后开始计时
            ryArmDongle.SetDeadline(uiHandle, uiTime, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("设置到期小时失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Set deadline time value[24] success. \r\n");
            textBox1.Text = strMsg;

            //2.设置日期值。例：2015-4-20 06:30:25
            long lSec = 0;
            dateTime = new System.DateTime(2015, 4, 20, 6, 30, 25, DateTimeKind.Utc);//到期时间为2015-4-20 06:30:25
            lSec = (dateTime.Ticks - standardTime.Ticks) / 100000000;
            uiTime = (uint)lSec;
            ryArmDongle.SetDeadline(uiHandle, uiTime, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("设置到期日期失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Set deadline date value[2015-4-20 06:30:25] success. \r\n");
            textBox1.Text = strMsg;

            //取消时间限制。此时值只能为0xFFFFFFFF
            uiTime = 0xFFFFFFFF;
            ryArmDongle.SetDeadline(uiHandle, uiTime, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("取消时间限制失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Cancel deadline time success. \r\n");
            textBox1.Text = strMsg;

            //获取到期时间。注意获取后的判断
            uiTime = 0;
            ryArmDongle.GetDeadline(uiHandle, ref uiTime, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("获取到期时间失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Get deadline time success. \r\n");
            textBox1.Text = strMsg;

            //判断到期时间值 
            //uiTime = 1~65535表示剩余小时数
            //uiTime > 65535(0xFFFF)表示截止日期，需要转换,详细见以下示例
            //uiTime = 0xFFFFFFFF表示不限制时间
            if (uiTime == 0xFFFFFFFF)
            {//不限制时间
                strMsg += string.Format("Not time limited. \r\n");
            }
            else
            {
                if ((uiTime < 0xFFFF) && (uiTime >1))
                {//
                    strMsg += string.Format("hours:{0:d}. \r\n", uiTime);
                }
                else
                {
                    secs = Convert.ToDouble(uiTime);
                    dateTime = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc).AddSeconds(secs);

                    strMsg += string.Format("Get Deadline date success.\r\n", uiError);
                    strMsg += string.Format(">>Date: {0:d4}-{1:d2}-{2:d2} {3:d2}:{4:d2}:{5:d2}. \r\n",
                        dateTime.Year, dateTime.Month, dateTime.Day, dateTime.Hour, dateTime.Minute, dateTime.Second);
                    textBox1.Text = strMsg;
                }
            }

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Close Dongle ARM success.\r\n", uiError);
            textBox1.Text = strMsg;
        }
    }
}