﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample08
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";
            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;


            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n");
            textBox1.Text = strMsg;

            //创建RSA私钥
            object vRSAPriAtrr = null;
            ushort usType = (ushort)DongleDef.FILE_PRIKEY_RSA;
            ushort usSize = 1024;//也可以为2048
            uint uiCallCount =  0xFFFFFFFF;//可被调用次数，0xFFFFFFFF表示不限制，当此值为0，改私钥不可调用。
            byte bPri = 1;//调用权限0：匿名；1：用户；2：开发商；
            byte bIsDecOnRam = 0;//是否在RAM中递减0：在Flash中递减；1：在RAM中递减
            byte bIsReset = 1; //调用完后是否回到匿名态1：回到匿名态；1：不回到匿名态
            uint uiRSAPriAttrLen = 0;
            ryArmDongle.Convert_PRIKEY_FILE_ATTR_To_Buffer(usType, usSize, uiCallCount, bPri, bIsDecOnRam, 
                bIsReset, ref vRSAPriAtrr, ref uiRSAPriAttrLen, ref uiError);
            ushort usFileID = 0x1111;
            ryArmDongle.CreateFile(uiHandle, DongleDef.FILE_PRIKEY_RSA, usFileID, vRSAPriAtrr, uiRSAPriAttrLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("创建RSA私钥失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Create RSA private success.\r\n");
            textBox1.Text = strMsg;

            //产生RSA公私钥对
            object rsaPub = null;
            object rsaPri = null;
            ryArmDongle.GenRSAPubPriKey(uiHandle, usFileID, ref rsaPub, ref rsaPri, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("产生RSA公私钥失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Gen rsa public key and private key success.\r\n");
            textBox1.Text = strMsg;

            byte[] rsaPubBuffer = (byte[])rsaPub;
            byte[] rsaPriBuffer = (byte[])rsaPri;

            FileStream fs = new FileStream("1111.Rsapub", FileMode.Create);
            fs.Write(rsaPubBuffer, 0, rsaPubBuffer.Length);
            fs.Close();

            fs = new FileStream("1111.Rsapri", FileMode.Create);
            fs.Write(rsaPriBuffer, 0, rsaPriBuffer.Length);
            fs.Close();

            //RSA 公钥加密
            byte [] bData = new byte [117];
            for (i = 0; i < 117; i++ )
            {
                bData[i] = (byte)i;
            }
            uint uiOutDataLen = 128;
            object vOutData = null;
            ryArmDongle.RSAPub(uiHandle, DongleDef.FLAG_ENCODE, rsaPub, (object)bData, 117, ref vOutData, ref uiOutDataLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("RSA公钥加密失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("RSA public key encode success.\r\n");
            textBox1.Text = strMsg;

            //RSA 私钥解密
            ryArmDongle.RSAPri(uiHandle, usFileID, DongleDef.FLAG_DECODE, vOutData, uiOutDataLen, ref vOutData, ref uiOutDataLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("RSA私钥解密失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("RSA private key decode success.\r\n");
            textBox1.Text = strMsg;

            //比较两个数组是否内容一致
            bool bSame = true;
            byte []bOutData = (byte[])vOutData;
            for (i = 0; i < bData.Length; i++ )
            {
                if (bData[i] != bOutData[i])
                {
                    bSame = false;
                    break;
                }
            }
            if (true != bSame)
            {
                strMsg += string.Format("公钥加密私钥解密结果不一致。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("RSA public key encode and private key decode success. \r\n");
            textBox1.Text = strMsg;
            
            //RSA 私钥加密
            uiOutDataLen = 128;//表示输出数据的最小长度
            ryArmDongle.RSAPri(uiHandle, usFileID, DongleDef.FLAG_ENCODE, (object)bData, 117, ref vOutData, ref uiOutDataLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("RSA私钥加密失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("RSA private key encode success.\r\n");
            textBox1.Text = strMsg;

            //RSA 公钥解密
            ryArmDongle.RSAPub(uiHandle, DongleDef.FLAG_DECODE, rsaPub, vOutData, uiOutDataLen, ref vOutData, ref uiOutDataLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("RSA公钥解密失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("RSA public key decode success.\r\n");
            textBox1.Text = strMsg;

            //比较两个数组是否内容一致
            bSame = true;
            bOutData = (byte[])vOutData;
            for (i = 0; i < bData.Length; i++)
            {
                if (bData[i] != bOutData[i])
                {
                    bSame = false;
                    break;
                }
            }
            if (true != bSame)
            {
                strMsg += string.Format("RSA私钥加密公钥解密加解密结果不一致。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Rsa private key encode and public key decode success. \r\n");
            textBox1.Text = strMsg;

            //删除RSA私钥
            ryArmDongle.DeleteFile(uiHandle, DongleDef.FILE_PRIKEY_RSA, usFileID, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("RSA私钥删除失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Delete rsa private key success.\r\n");
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Close Dongle ARM success.\r\n", uiError);
            textBox1.Text = strMsg;

        }
    }
}