﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;
using System.IO;

namespace Sample09
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";
            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;


            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;                
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n");
            textBox1.Text = strMsg;

            //创建ECC私钥
            object vECCPriAtrr = null;
            ushort usType = (ushort)DongleDef.FILE_PRIKEY_RSA;
            ushort usSize = 192;//也可以为256
            uint uiCallCount = 0xFFFFFFFF;//可被调用次数，0xFFFFFFFF表示不限制，当此值为0，改私钥不可调用。
            byte bPri = 1;//调用权限0：匿名；1：用户；2：开发商；
            byte bIsDecOnRam = 0;//是否在RAM中递减0：在Flash中递减；1：在RAM中递减
            byte bIsReset = 1; //调用完后是否回到匿名态1：回到匿名态；1：不回到匿名态
            uint uiECCPriAttrLen = 0;
            ryArmDongle.Convert_PRIKEY_FILE_ATTR_To_Buffer(usType, usSize, uiCallCount, bPri, bIsDecOnRam,
                bIsReset, ref vECCPriAtrr, ref uiECCPriAttrLen, ref uiError);
            ushort usFileID = 0x2222;
            ryArmDongle.CreateFile(uiHandle, DongleDef.FILE_PRIKEY_ECCSM2, usFileID, vECCPriAtrr, uiECCPriAttrLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("创建ECC私钥失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Create ECC private success.\r\n");
            textBox1.Text = strMsg;

            //产生ECC公私钥对
            object eccPub = null;
            object eccPri = null;
            ryArmDongle.GenECCPubPriKey(uiHandle, usFileID, ref eccPub, ref eccPri, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("产生ECC公私钥失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Gen ecc public key and private key success.\r\n");
            textBox1.Text = strMsg;

            byte[] eccPubBuffer = (byte[])eccPub;
            byte[] eccPriBuffer = (byte[])eccPri;

            FileStream fs = new FileStream("2222.EccSm2pub", FileMode.Create);
            fs.Write(eccPubBuffer, 0, eccPubBuffer.Length);
            fs.Close();

            fs = new FileStream("2222.EccSm2pri", FileMode.Create);
            fs.Write(eccPriBuffer, 0, eccPriBuffer.Length);
            fs.Close();
                        
            byte[]bHash = new byte[24];
            object vOutData = null;
            for (i = 0; i < 24; i++)
            {
                bHash[i] = (byte)i;
            }

            //ECC签名
            ryArmDongle.ECCSign(uiHandle, usFileID, (object)bHash, 24, ref vOutData, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("ECC签名失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("ECC private key sign success.\r\n");
            textBox1.Text = strMsg;

            //ECC验签
            ryArmDongle.ECCVerify(uiHandle, (object)eccPub, (object)bHash, 24, vOutData, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("ECC验签失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("ECC public key verify success.\r\n");
            textBox1.Text = strMsg;

            //删除ECC私钥
            ryArmDongle.DeleteFile(uiHandle, DongleDef.FILE_PRIKEY_ECCSM2, usFileID, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("ECC私钥删除失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Delete ecc private key success.\r\n");
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Close Dongle ARM success.\r\n", uiError);
            textBox1.Text = strMsg;
        }
    }
}