﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;
using System.IO;

namespace Sample10
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";
            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;


            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n");
            textBox1.Text = strMsg;

            //创建SM2私钥
            object vSM2PriAtrr = null;
            ushort usType = (ushort)DongleDef.FILE_PRIKEY_RSA;
            ushort usSize = 0x8100;//SM2私钥值必为0x8100
            uint uiCallCount = 0xFFFFFFFF;//可被调用次数，0xFFFFFFFF表示不限制，当此值为0，改私钥不可调用。
            byte bPri = 1;//调用权限0：匿名；1：用户；2：开发商；
            byte bIsDecOnRam = 0;//是否在RAM中递减0：在Flash中递减；1：在RAM中递减
            byte bIsReset = 1; //调用完后是否回到匿名态1：回到匿名态；1：不回到匿名态
            uint uiSM2PriAttrLen = 0;
            ryArmDongle.Convert_PRIKEY_FILE_ATTR_To_Buffer(usType, usSize, uiCallCount, bPri, bIsDecOnRam,
                bIsReset, ref vSM2PriAtrr, ref uiSM2PriAttrLen, ref uiError);
            ushort usFileID = 0x3333;
            ryArmDongle.CreateFile(uiHandle, DongleDef.FILE_PRIKEY_ECCSM2, usFileID, vSM2PriAtrr, uiSM2PriAttrLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("创建SM2私钥失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Create SM2 private success.\r\n");
            textBox1.Text = strMsg;

            //产生SM2公私钥对
            object sm2Pub = null;
            object sm2Pri = null;
            ryArmDongle.GenSM2PubPriKey(uiHandle, usFileID, ref sm2Pub, ref sm2Pri, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("产生SM2公私钥失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Gen sm2 public key and private key success.\r\n");
            textBox1.Text = strMsg;

            byte[] sm2PubBuffer = (byte[])sm2Pub;
            byte[] sm2PriBuffer = (byte[])sm2Pri;

            FileStream fs = new FileStream("3333.EccSm2pub", FileMode.Create);
            fs.Write(sm2PubBuffer, 0, sm2PubBuffer.Length);
            fs.Close();

            fs = new FileStream("3333.EccSm2pri", FileMode.Create);
            fs.Write(sm2PriBuffer, 0, sm2PriBuffer.Length);
            fs.Close();

            byte[] bHash = new byte[32];//签名数据不能超过32字节
            object vOutData = null;
            for (i = 0; i < 32; i++)
            {
                bHash[i] = (byte)i;
            }

            //SM2签名
            ryArmDongle.SM2Sign(uiHandle, usFileID, (object)bHash, 32, ref vOutData, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("SM2签名失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("SM2 private key sign success.\r\n");
            textBox1.Text = strMsg;

            //SM2验签
            ryArmDongle.SM2Verify(uiHandle, sm2Pub, (object)bHash, 32, vOutData, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("SM2验签失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("SM2 public key verify success.\r\n");
            textBox1.Text = strMsg;

            //删除SM2私钥
            ryArmDongle.DeleteFile(uiHandle, DongleDef.FILE_PRIKEY_ECCSM2, usFileID, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("SM2私钥删除失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Delete sm2 private key success.\r\n");
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Close Dongle ARM success.\r\n");
            textBox1.Text = strMsg;
        }
    }
}