﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample11
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";
            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;


            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;                
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n");
            textBox1.Text = strMsg;

            //创建3DES/SM4密钥
            object vKeyAtrr = null;
            ushort usType = (ushort)DongleDef.FILE_KEY;
            ushort usSize = 16;
            uint uiKeyAttrLen = 0;
            uint uiEncPriv = 1;//加密权限0：匿名；1：用户；2：开发商；
            ryArmDongle.Convert_KEY_FILE_ATTR_To_Buffer(usSize, uiEncPriv, ref vKeyAtrr, ref uiKeyAttrLen, ref uiError);
            ushort usFileID = 0x4444;
            ryArmDongle.CreateFile(uiHandle, usType, usFileID, vKeyAtrr, uiKeyAttrLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("创建密钥文件失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Create key file success.\r\n");
            textBox1.Text = strMsg;

            object vRandom = null;
            ryArmDongle.GenRandom(uiHandle, 16, ref vRandom, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("获取随机数失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Get random success.\r\n");
            textBox1.Text = strMsg;

            ryArmDongle.WriteFile(uiHandle, DongleDef.FILE_KEY, usFileID, 0, vRandom, 16, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("写密钥文件失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Write key file success.\r\n");
            textBox1.Text = strMsg;

            //3DES加解密
            byte[] buffer = new byte[1024];
            for (i = 0; i < 1024; i++ )
            {
                buffer[i] = (byte)i;
            }
            object vOutData = null;
            uint uiDataLen = 1024;
            ryArmDongle.TDES(uiHandle, usFileID, DongleDef.FLAG_ENCODE, (object)buffer, ref vOutData, uiDataLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("3DES加密失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("3DES encode success.\r\n");
            textBox1.Text = strMsg;

            ryArmDongle.TDES(uiHandle, usFileID, DongleDef.FLAG_DECODE, vOutData, ref vOutData, uiDataLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("3DES解密失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("3DES decode success.\r\n");
            textBox1.Text = strMsg;

            byte[]bOutData = (byte[])vOutData;
            bool isSame = true;
            for (i = 0; i < 1024; i++ )
            {
                if (buffer[i] != bOutData[i])
                {
                    isSame = false;
                    break;
                }
            }
            if (isSame == false)
            {
                strMsg += string.Format("3DES加解密结果不一致\r\n");
            }
            strMsg += string.Format("3DES encode and decode is correct!\r\n");
            textBox1.Text = strMsg;

            for (i = 0; i < 1024; i++)
            {
                buffer[i] = (byte)i;
            }
            ryArmDongle.SM4(uiHandle, usFileID, DongleDef.FLAG_ENCODE, (object)buffer, ref vOutData, uiDataLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("SM4加密失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("SM4 encode success.\r\n");
            textBox1.Text = strMsg;

            ryArmDongle.SM4(uiHandle, usFileID, DongleDef.FLAG_DECODE, vOutData, ref vOutData, uiDataLen, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("SM4解密失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("SM4 decode success.\r\n");
            textBox1.Text = strMsg;

            bOutData = (byte[])vOutData;
            isSame = true;
            for (i = 0; i < 1024; i++)
            {
                if (buffer[i] != bOutData[i])
                {
                    isSame = false;
                    break;
                }
            }
            if (isSame == false)
            {
                strMsg += string.Format("SM4加解密结果不一致\r\n");
            }
            strMsg += string.Format("SM4 encode and decode is correct!\r\n");
            textBox1.Text = strMsg;

            //删除密钥
            ryArmDongle.DeleteFile(uiHandle, DongleDef.FILE_KEY, usFileID, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("密钥文件删除失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Delete 3DES/SM4 key success.\r\n");
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Close Dongle ARM success.\r\n");
            textBox1.Text = strMsg;
        }
    }
}