﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample12
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            
            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";
            int i = 0;

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;


            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;                
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            byte [] bData = new byte [128];
            for(i = 0; i < 128; i++) bData[i] = (byte)i;
            object vOutData = null;
            ryArmDongle.HASH(uiHandle, DongleDef.FLAG_HASH_MD5, (object)bData, 128, ref vOutData, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("MD5运算失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("MD5 success.\r\n");
            strMsg += string.Format("Result: \r\n");
            byte[] bHash = (byte[])vOutData;
            for (i = 0; i < bHash.Length; i++)
            {
                strMsg += string.Format("{0:X2} ", bHash[i]);
            }
            strMsg += "\r\n";
            textBox1.Text = strMsg;

            ryArmDongle.HASH(uiHandle, DongleDef.FLAG_HASH_SHA1, (object)bData, 128, ref vOutData, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("SHA1运算失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("SHA1 success.\r\n");
            strMsg += string.Format("Result: \r\n");
            bHash = (byte[])vOutData;
            for (i = 0; i < bHash.Length; i++)
            {
                strMsg += string.Format("{0:X2} ", bHash[i]);
            }
            strMsg += "\r\n";
            textBox1.Text = strMsg;

            ryArmDongle.HASH(uiHandle, DongleDef.FLAG_HASH_SM3, (object)bData, 128, ref vOutData, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("SM3运算失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("SM3 success.\r\n");
            strMsg += string.Format("Result: \r\n");
            bHash = (byte[])vOutData;
            for (i = 0; i < bHash.Length; i++)
            {
                strMsg += string.Format("{0:X2} ", bHash[i]);
            }
            strMsg += "\r\n";
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Close Dongle ARM success.\r\n");
            textBox1.Text = strMsg;
        }
    }
}