﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample13
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";
            byte []seed = new byte [250]; 
            int i = 0;

            for (i = 0; i < 250; i++)
            {
                seed[i] = 0x22;
            }

            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;


            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n", uiError);
            textBox1.Text = strMsg;

            //设置种子码运算次数.本例中限制种子码元素3次
            ryArmDongle.LimitSeedCount(uiHandle, 3, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("种子码运算次数设置失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Set seed limit count[3] success.\r\n", uiError);
            textBox1.Text = strMsg;

            //运算4次，看是否第四次失败            
            object vOutData = null;
            for (i = 0; i < 4; i++ )
            {
                ryArmDongle.Seed(uiHandle, (object)seed, 250, ref vOutData, ref uiError);
                if (uiError != DongleDef.DONGLE_SUCCESS)
                {
                    strMsg += string.Format("Seed [{0:d}] .Error：{1:X8}\r\n", i, uiError);
                    textBox1.Text = strMsg;
                    break;
                }
                strMsg += string.Format("Seed [{0:d}] result: \r\n", i);
                byte []bOutData = (byte[])vOutData;
                for (int j = 0; j < bOutData.Length; j++ )
                {
                    strMsg += string.Format("{0:X2} ", bOutData[j]);
                }
                strMsg += "\r\n";
                textBox1.Text = strMsg;
            }

            //设置种子码运算次数.设置为不限制 0xFFFFFFFF
            ryArmDongle.LimitSeedCount(uiHandle, 0xFFFFFFFF, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("种子码运算次数设置失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Set seed unlimited count[-1] success.\r\n", uiError);
            textBox1.Text = strMsg;

            //关闭加密锁
            ryArmDongle.Close(uiHandle, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Close Dongle ARM success.\r\n");
            textBox1.Text = strMsg;
        }
    }
}