﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Dongle;

namespace Sample14
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            object bDongleInfo = null;//加密锁信息
            uint uiCount = 0;//Dongle数量
            uint uiError = 0;//错误码
            string sPin = "FFFFFFFFFFFFFFFF";//默认的开发商密码
            uint uiRemainCount = 0;

            uint uiHandle = 0;//加密锁句柄
            uint uiIndex = 0;//序号
            string strMsg = "";

            uint uiVer = 0; //版本号
            uint uiAgent = 0; //代理编号
            uint uiPID = 0;  //产品ID
            uint uiUID = 0;  //用户ID
            uint uiDevType = 0;//设备类型
            uint uiIsMother = 0; //母锁标识
            uint uiType = 0; //产品类型
            object vHID = null; //HID，硬件序列号
            object vBirthday = null; //生产日期
            
            Dongle.DongleClass ryArmDongle = new Dongle.DongleClass();
            textBox1.Text = "";
            textBox1.Clear();//清空数据

            //1.枚举加密锁
            ryArmDongle.Enum(ref bDongleInfo, ref uiCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("枚举锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Enum Dongle ARM count:[{0}].\r\n", uiCount);
            textBox1.Text = strMsg;
            
            //打开加密锁
            ryArmDongle.Open(ref uiHandle, uiIndex, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("打开锁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                return;
            }
            strMsg += string.Format("Open Dongle ARM [0] success.\r\n");
            textBox1.Text = strMsg;

            //LED灯的控制，调试程序可见
            ryArmDongle.LEDControl(uiHandle, DongleDef.LED_OFF, ref uiError);//关闭
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("设置加密锁LED灯关闭失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Set LED [OFF] success.\r\n");
            textBox1.Text = strMsg;
            
            ryArmDongle.LEDControl(uiHandle, DongleDef.LED_BLINK, ref uiError);//闪烁
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("设置加密锁LED灯闪烁失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Set LED [BLINK] success.\r\n");
            textBox1.Text = strMsg;

            ryArmDongle.LEDControl(uiHandle, DongleDef.LED_ON, ref uiError);//打开
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("设置加密锁LED灯打开失败。 错误码：{0:X8}", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Set LED [ON] success.\r\n");
            textBox1.Text = strMsg;

            //验证开发商密码
            ryArmDongle.VerifyPIN(uiHandle, DongleDef.FLAG_ADMINPIN, sPin, ref uiRemainCount, ref uiError);
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("校验开发商PIN失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Verify administrator pin success.\r\n", uiError);
            textBox1.Text = strMsg;

            
            //从枚举的数据中获取每一把加密锁的相关数据
            ryArmDongle.GetDongleInfo(bDongleInfo, 0, ref uiVer, ref vBirthday,
                                      ref uiAgent, ref uiPID, ref uiUID, ref vHID,
                                      ref uiDevType, ref uiIsMother, ref uiType);

            //切换通讯协议
            if (uiDevType == DongleDef.PROTOCOL_CCID)
            {//如果是CCID设备
                ryArmDongle.SwitchProtocol(ref uiHandle, DongleDef.PROTOCOL_HID, ref uiError);
            }
            else if (uiDevType == DongleDef.PROTOCOL_HID)
            {//如果是HID设备
                ryArmDongle.SwitchProtocol(ref uiHandle, DongleDef.PROTOCOL_CCID, ref uiError);
            }
            if (uiError != DongleDef.DONGLE_SUCCESS)
            {
                strMsg += string.Format("切换协议失败。 错误码：{0:X8}\r\n", uiError);
                textBox1.Text = strMsg;
                ryArmDongle.Close(uiHandle, ref uiError);
                return;
            }
            strMsg += string.Format("Switch protocol success.\r\n", uiError);
            textBox1.Text = strMsg;

            //切换协议后不需要关闭加密锁，因为句柄已经无效
            //如果非要关闭的话，就会返回0xF0000002的错误，这属于正常
            ryArmDongle.Close(uiHandle, ref uiError);
            //if (uiError != DongleDef.DONGLE_SUCCESS)
            //{
            //    strMsg += string.Format("关闭加密锁失败。 错误码：{0:X8}\r\n", uiError);
            //    textBox1.Text = strMsg;
            //    return;
            //}
            strMsg += string.Format("Close Dongle ARM .\r\n");
            textBox1.Text = strMsg;
        }
    }
}